% Lineare Regression : Annherung einer Messwertreihe durch
% ein Polynom
% Version 2 ohne interaktivem Werteeinlesen
%  1996 by Andreas Meile, HTL Brugg-Windisch

% Zuerst die beiden Zeilenvektoren x und y prfen

% berhaupt definiert?
if ~(exist('x') & exist('y'))
  disp('Die x-Werte und y-Werte mssen sich je auf einem');
  disp('Zeilenvektor "x" und "y" befinden!');
  return;
end;

% berhaupt Zeilenvektoren?
if ~((size(x,1) == 1) & (size(x,2) >= 1) & (size(y,1) == 1) & (size(y,2) >= 1))
  disp('Die Werte mssen als einzeilige Matrizen, d.h.');
  disp('als Zeilenvektoren vorliegen!');
  return;
end;

% Gleiche Grsse?
if size(x,2) ~= size(y,2)
  disp('Beide Zeilenvektoren mssen gleich viele Elemente enthalten!');
  return;
end;

m1=2;
m2=1;

while m2 < m1,
  m1 = input('Startindex (Exponent [1=durch Nullpunkt])? ');
  m2 = input('Endindex (Exponent [1=Gerade, 2=Parabel etc.])? ');
end;

% Anzahl Variablen
m=m2-m1+1;

% Exponentenmatrix erzeugen
ex=(m1:1:m2)';

% Matrix A mit Funktionswerten erzeugen
A = [];
for i=1:size(x,2)
  A(:,i) = x(i).^ex;
end;

% Regressionskoeffizienten berechnen
a=(A*A')\(A*y')

% Ausgeglichene Werte berechnen
w=a'*A

disp('Die Faktoren fr das Polynom lauten:')
disp(a);
disp('Die auslinearisierte Messreihe (x-Werte, y gem., y ber.):');
disp([x;y;w]);

disp('Weiter mit Taste');

% Grafischer Plot
plot(x, w, 'y', x, y, 'co');
pause;
close;