% Lineare Regression : Annherung einer Messwertreihe durch
% ein Polynom
%  1996 by Andreas Meile, HTL Brugg-Windisch

clear;
m1=2;
m2=1;

while m2 < m1,
  m1 = input('Startindex (Exponent [1=durch Nullpunkt])? ');
  m2 = input('Endindex (Exponent [1=Gerade, 2=Parabel etc.])? ');
end;

% Anzahl Variablen
m=m2-m1+1;

% Exponentenmatrix erzeugen
ex=(m1:1:m2)';

% Einlesen der Werte
disp('Zum Beenden bitte eine Leereingabe machen!');
x=[];
verlass = 0;
while verlass == 0,
  t=input('x-Vorgabewert? ');
  if size(t) ~= [1 1]
    verlass=1;
  else
    x(size(x,2)+1) = t;
	t=[];
	while size(t) ~= [1 1],
	  t = input('Dazugehriger y-Messwert? ');
	end;
	y(size(x,2)) = t;
  end;
end;

% Matrix A mit Funktionswerten erzeugen
for i=1:size(x,2)
  A(:,i) = x(i).^ex;
end;

% Regressionskoeffizienten berechnen
a=(A*A')\(A*y')

% Ausgeglichene Werte berechnen
w=a'*A

disp('Die Faktoren fr das Polynom lauten:')
disp(a);
disp('Die auslinearisierte Messreihe (x-Werte, y gem., y ber.):');
disp([x;y;w]);

disp('Weiter mit Taste');

% Grafischer Plot
plot(x, w, 'y', x, y, 'co');
pause;
close;
